
#define A       PD_ODR_ODR7
#define B       PD_ODR_ODR6
#define C       PD_ODR_ODR5
#define D       PD_ODR_ODR4
#define E       PD_ODR_ODR3
#define F       PD_ODR_ODR2
#define G       PD_ODR_ODR0
#define DP      PC_ODR_ODR7

#define N0      PC_ODR_ODR3
#define N0_ddr  PC_DDR_DDR3
#define N0_idr  PC_IDR_IDR3
#define N1      PC_ODR_ODR4
#define N1_ddr  PC_DDR_DDR4
#define N2      PC_ODR_ODR5 
#define N2_ddr  PC_DDR_DDR5
#define N3      PC_ODR_ODR6
#define N3_ddr  PC_DDR_DDR6

#define DNUM    4

bool ss_pol;   //0==CC

#if DNUM==2 
u8 dbuf[DNUM]  = {'_','_'};
bool dpp[DNUM] = {0,0};
#elif DNUM==3 
u8 dbuf[DNUM]  = {'_','_','_'};
bool dpp[DNUM] = {0,0,0}; 
#elif DNUM==4 
u8 dbuf[DNUM]  = {'_','_','_','_'};
bool dpp[DNUM] = {0,0,0,0};
#endif 

void display_data ()//(const u8 dbuf[],const bool dpp[],const bool ss_pol)
{
 static u8 sp;
 static u8 dtmp[DNUM];
 static bool dptmp[DNUM]; 
 static u8 tmp[DNUM]; 
 u8 i;
 
 for(i=0;i<DNUM;i++)
 {
  if(dtmp[i]!=dbuf[i] || dptmp[i]!=dpp[i]) 
  {
   dtmp[i]  = dbuf[i];
   dptmp[i] = dpp[i];
   
   switch (dbuf[i])
   {
    case 0: tmp[i] = bin(0000001); break;
    case 1: tmp[i] = bin(1001111); break;
    case 2: tmp[i] = bin(0010010); break;
    case 3: tmp[i] = bin(0000110); break;
    case 4: tmp[i] = bin(1001100); break;
    case 'S':
    case 5: tmp[i] = bin(0100100); break;
    case 6: tmp[i] = bin(0100000); break;
    case 7: tmp[i] = bin(0001111); break;
    case 8: tmp[i] = bin(0000000); break;
    case 9: tmp[i] = bin(0000100); break;

    case 10: tmp[i] = bin(0111111); break;
    case 11: tmp[i] = bin(1011111); break;
    case 12: tmp[i] = bin(1101111); break;
    case 13: tmp[i] = bin(1110111); break;
    case 14: tmp[i] = bin(1111011); break;
    case 15: tmp[i] = bin(1111101); break;
    case 16: tmp[i] = bin(1111110); break;

    case ' ': tmp[i] = bin(1111111); break;
    case 'v':
    case 'u': tmp[i] = bin(1100011); break;
    case 'c': tmp[i] = bin(1110010); break;
    case 'b': tmp[i] = bin(1100000); break;
    case 't': tmp[i] = bin(1110000); break;
    case 'l': tmp[i] = bin(1110011); break;
    case 'o': tmp[i] = bin(1100010); break;
    case 'A': tmp[i] = bin(0001000); break;
    case 'H': tmp[i] = bin(1001000); break;
    case 'C': tmp[i] = bin(0110001); break;
    case 'P': tmp[i] = bin(0011000); break;
    case 'E': tmp[i] = bin(0110000); break;
    case 'U': tmp[i] = bin(1000001); break;
    case 'f':
    case 'F': tmp[i] = bin(0111000); break;
    case 'L': tmp[i] = bin(1110001); break;
    case 'r': tmp[i] = bin(1111010); break;
    case '_': tmp[i] = bin(1110111); break;
    case 'd': tmp[i] = bin(1000010); break;
    case 'n': tmp[i] = bin(1101010); break;
    case 'G': tmp[i] = bin(0100001); break;
    case 'N': tmp[i] = bin(0001001); break;
    case 'O': tmp[i] = bin(0000001); break;
    case 'i': tmp[i] = bin(1111011); break;
    case 'I': tmp[i] = bin(1111001); break;
    case 'J': tmp[i] = bin(1000111); break;
    case 'h': tmp[i] = bin(1101000); break;
    default:  tmp[i] = bin(1111110); break; //-
   }
   tmp[i]|=~dpp[i]<<7;
   
   if(ss_pol)tmp[i]=~tmp[i];
  } 
 }
 
 sp?sp--:sp=7;
 i=1<<sp;
       
 A=B=C=D=E=F=G=DP=ss_pol; 
 
#if   DNUM==2 
 N0 = !!(tmp[0]&i);
 N1 = !!(tmp[1]&i);
#elif DNUM==3 
 N0 = !!(tmp[0]&i);
 N1 = !!(tmp[1]&i);
 N2 = !!(tmp[2]&i); 
#elif DNUM==4 
 N0 = !!(tmp[0]&i);
 N1 = !!(tmp[1]&i);
 N2 = !!(tmp[2]&i);                      
 N3 = !!(tmp[3]&i);  
#endif 
 
 i = !ss_pol;
 
 switch(sp)
 {  
  case 7: DP=i;
  break;   
  case 6: A=i;
  break;  
  case 5: B=i;
  break;   
  case 4: C=i;
  break;  
  case 3: D=i;
  break;  
  case 2: E=i;
  break;  
  case 1: F=i;
  break;  
  case 0: G=i;
  break;   
 }     
}

void detect_7seg_polarity(bool &ssg_pl)
{
 u8 n=0;

 A=B=C=D=E=F=G=DP=0;

#if DNUM==2 
 N1=N0=       N1_ddr=N0_ddr=0;
#elif DNUM==3 
 N2=N1=N0=    N2_ddr=N1_ddr=N0_ddr=0;
#elif DNUM==4 
 N3=N2=N1=N0= N3_ddr=N2_ddr=N1_ddr=N0_ddr=0; 
#endif  

 for(u8 i=0xff;i;i--)
 {
  if(!N0_idr)n++;
  else if(n)n--;
 }
  if(n>0xff/2)ssg_pl=1;
  else ssg_pl=0;
  
#if   DNUM==2 
 N1_ddr=N0_ddr=1;
#elif DNUM==3 
 N2_ddr=N1_ddr=N0_ddr=1;
#elif DNUM==4 
 N3_ddr=N2_ddr=N1_ddr=N0_ddr=1; 
#endif    
}

void convert_data (u16 d)
{
 for (u8 k=0;k<DNUM;k++)
  {
   dbuf[k]=d%10;
   d/=10;
  }
 //if(!dbuf[DNUM-1])dbuf[DNUM-1]=' ';
 if(dpp[3])if(!dbuf[DNUM-2])dbuf[DNUM-2]=' ';
}

