/**************************************************
 * Copyright 2007 IAR Systems. All rights reserved.
 *
 * $Revision: 1578 $
 *
 * A simple implementation of the crc-16 checksum algorithm.
 *
 * Note that if you use this algorithm/function, you need to call it with
 * an extra number of zero bytes equal to the size of the checksum
 * (in this case 2), to "rotate out the answer".
 **************************************************/
extern u16 __checksum; 
  
u16 Crc16(u16 start_pos,u16 end_pos)
{
 u16 sum = 0; 
 u8 zeros[2]={0,0};
 bool trg=1;
 u8 *p  = (u8*)start_pos;
 u8 *p1 = (u8*)end_pos;
 u16 len = p1-p+1;
 
 m:
 while (len--) 
 { 
  u8 byte = *(p++); 
  for (u8 i = 0; i < 8; ++i) 
  { 
   u16 osum = sum; 
   sum <<= 1; 
   if (byte & 0x80)   sum |= 1; 
   if (osum & 0x8000) sum ^= 0x1021; 
   byte <<= 1; 
  } 
 }  
 
 if(trg) 
 {
  trg = 0;
  len = 2; 
  p   = zeros;  
  goto m;
 } 

 return sum;
}

bool TestFlash(void)
{  
 if(Crc16(0x8000,0x9ffd)!=__checksum)
 return 0; 
 return 1;
}


