
__no_init
struct initval
{
 u32 new_osc_frg;
 u8  osc_init; 
 u32 osc_frq; 
 u8  init; 
 u32 base_frq;
 u32 Vref;
 u32 Vac_out; 
 u32 R1;
 u32 R2;
 
 u16 checksum;
} eep @ 0x4000; 

class //periph_init
{
 public:
 void ee()
 {
  #define sgn 0x01
  #define osv 0x01
  if(eep.init!=sgn)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);

   eep.init     = sgn;
   eep.osc_init = osv;
   eep.osc_frq  = quartz_frq; 
   eep.new_osc_frg = quartz_frq;
   eep.base_frq = base_frequency;
   eep.Vref     = reference_voltage;
   eep.R1       = Res_1;
   eep.R2       = Res_2;
   eep.Vac_out  = output_ac_voltage;

   eep.checksum = Crc16(0x4000,0x4000+sizeof(initval)-2-1);   
   FLASH_Lock(FLASH_MEMTYPE_DATA);
  }
  else if(eep.osc_init!=osv)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);

   eep.osc_frq  = eep.new_osc_frg;
   eep.osc_init = osv;

   eep.checksum = Crc16(0x4000,0x4000+sizeof(initval)-2-1);     
   FLASH_Lock(FLASH_MEMTYPE_DATA);   
  }
 } 
 void gpio()
 {
  PA_CR1 = 0xff;
  PA_ODR = 0;  
  PA_DDR = 0;

  PB_CR1 = 0xff-(1<<7|1<<6|1<<3|1<<2);
  PB_ODR = 1<<1|1;
  PB_DDR = 1<<1|1;

  PC_CR1 = 0xff;
  PC_ODR = 0;
  PC_DDR = 0xff;

  PD_CR1 = 0xff;
  PD_ODR = 0;     
  PD_DDR = 0xff-2;

  PE_CR1 = 0xff;
  PE_ODR = 0;
  PE_DDR = 0xff;

  PF_CR1 = 0xff;
  PF_ODR = 0;
  PF_DDR = 0;
 }
 bool clk()
 {
  CLK_DeInit();
  CLK->ECKR  = CLK_ECKR_HSEEN;
  CLK->PCKENR1 = CLK_PCKENR1_TIM1|CLK_PCKENR1_TIM2;
  CLK->CKDIVR = 0;
  for(volatile u16 i=0xffff;i;i--)
  {
   if(CLK->ECKR&CLK_ECKR_HSERDY)
   {
    CLK->SWR   = 0xb4;
    while(!(CLK->SWCR&CLK_SWCR_SWIF));
    CLK->SWCR |= CLK_SWCR_SWEN;
    CLK->SWCR = 0;    
    CLK->CSSR = CLK_CSSR_CSSEN|CLK_CSSR_CSSDIE;    
    return 1;
   }
  }   
  return 0; 
 } 
 void t1(u32 mcu_frq, u16 spwm_frq)
 {
  u16 arr = mcu_frq/spwm_frq/2-1;

  TIM1->ARRH  = arr>>8; 
  TIM1->ARRL  = (u8)arr; 
  TIM1->CR1   = TIM1_COUNTERMODE_CENTERALIGNED1|TIM1_CR1_URS; 
  TIM1->CR2   = TIM1_CR2_CCPC; 
  TIM1->RCR   = 1; 
  TIM1->IER   = TIM1_IER_UIE; 

  TIM1->CR2  |= TIM1_CR2_MMS;
  TIM1->CCR4H = arr-1>>8;
  TIM1->CCR4L = u8(arr-1);
  TIM1->CCMR4 = TIM1_OCMODE_PWM1;

  TIM1->CCER1 = 0xff - TIM1_CCER1_CC1P - TIM1_CCER1_CC2P;
  TIM1->CCMR1 = pwm1|TIM1_CCMR_OCxPE;
  TIM1->CCMR2|= force_inactive|TIM1_CCMR_OCxPE;

  TIM1->EGR  |= TIM1_EGR_COMG;

  TIM1->DTR   = u8(dt_ns/100*(u32)mcu_frq/1E7);
  TIM1->BKR   = TIM1_LOCKLEVEL_1;  
  TIM1->CR1  |= TIM1_CR1_CEN;
 }
 void t2(u32 mcu_frq, u16 i_frq)  
 {
  u32 x=1;

  for(u8 i=1;i<0x10;i++)
  {
   x=x*2;
   if(mcu_frq/x<0x10000){TIM2->PSCR=i; break;}
  }

  TIM2->ARRH  = (u8)((u32)mcu_frq/x/i_frq-1>>8);
  TIM2->ARRL  = (u8)(mcu_frq/x/i_frq-1);

  TIM2->IER   = 1;
  TIM2->CR1   = 1;
 }
 void adc()
 {
  ADC1->CR1  = ADC1_PRESSEL_FCPU_D18;
  ADC1->CR2  = ADC1_ALIGN_RIGHT|ADC1_CR2_EXTTRIG;
  ADC1->CSR  = 2;
  ADC1->TDRL = 1<<3|1<<2;

  ADC1->CR1 |= ADC1_CR1_ADON;
 }
 void iwdg() 
 {
  IWDG_Enable();
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
  IWDG_SetPrescaler(IWDG_Prescaler_256);
  IWDG_SetReload(0xff); 
  IWDG_ReloadCounter();
 }
}cfg;

bool TestEE()
{
 if(Crc16(0x4000,0x4000+sizeof(initval)-2-1)!=eep.checksum)
 return 0; 
 return 1;
} 
