
#define spwm_frq      (u16)16E3
#define wave_min_frq  30
#define wave_max_frq  400

struct sw_parameters
{
 u16 base_frq; 
 u16 steps;
 u16 table[spwm_frq/wave_min_frq/4];
 u8  level;
} s_wave;

void calc_base_wave(sw_parameters &s, u16 counter_topval)
{
 if(s.base_frq<wave_min_frq)s.base_frq=wave_min_frq;
 if(s.base_frq>wave_max_frq)s.base_frq=wave_max_frq;
 s.steps = spwm_frq/s.base_frq/4-1;
 
 for(u8 i=0;i<s.steps;i++) 
  s.table[i] = u16(counter_topval*sin(3.1415/2*i/(s.steps-1)));
 for(u8 i=s.steps;i<sizeof(s.table)/sizeof(int);i++)s.table[i]=0;
}

u8 calc_wave_level (u16 HV, u16 Vout)
{
 return u8((u32)Vout*1414*0xff/HV/1000);
}